unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    rhoEdit: TLabeledEdit;
    sumEdit: TLabeledEdit;
    KcalcBtn: TBitBtn;
    kEdit: TLabeledEdit;
    CdEdit: TLabeledEdit;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    mEdit: TLabeledEdit;
    tEdit: TLabeledEdit;
    gEdit: TLabeledEdit;
    vhBtn: TBitBtn;
    GroupBox3: TGroupBox;
    m1Edit: TLabeledEdit;
    h1Edit: TLabeledEdit;
    g1Edit: TLabeledEdit;
    tvBtn: TBitBtn;
    GroupBox4: TGroupBox;
    g2Edit: TLabeledEdit;
    t2Edit: TLabeledEdit;
    vh2Btn: TBitBtn;
    h2Edit: TLabeledEdit;
    tv2btn: TBitBtn;
    GroupBox5: TGroupBox;
    g3Edit: TLabeledEdit;
    t3Edit: TLabeledEdit;
    k3Edit: TLabeledEdit;
    m3Edit: TLabeledEdit;
    vh3Btn: TBitBtn;
    procedure KcalcBtnClick(Sender: TObject);
    procedure vhBtnClick(Sender: TObject);
    procedure tvBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure vh2BtnClick(Sender: TObject);
    procedure tv2btnClick(Sender: TObject);
    procedure vh3BtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

// C̒Rꍇŋ玞ԂƑxvZ
procedure TForm1.tv2btnClick(Sender: TObject);
var
  t   : double;   //       sec
  g   : double;   // d͉x    m/sec^2
  v   : double;   // x      m/s
  h   : double;   //           m
  ch  : integer;
begin
  memo1.Clear;
  val(h2Edit.Text, h, ch);
  if ch <> 0 then begin
    Memo1.Text := 'h:ɊԈႢ܂B';
    exit;
  end;
  if h <= 0 then begin
    Memo1.Text := 'h:̒l0([)傫ĂB';
    exit;
  end;
  val(g2Edit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  t := sqrt(2 * h / g);
  v := g * t;
  memo1.Lines.Append('');
  memo1.Lines.Append(' t = ' + floatTostr(t) + ' sec');
  memo1.Lines.Append('x');
  memo1.Lines.Append(' v = ' + floatTostr(v) + ' m/s');
end;

// C̒Rx̂QɔႷ̂Ƃċ玞ԂƑxvZ
procedure TForm1.tvBtnClick(Sender: TObject);
var
  k   : double;   // CRW  kg/m
  m   : double;   //           kg
  t   : double;   //       sec
  g   : double;   // d͉x    m/sec^2
  v   : double;   // x      m/s
  h   : double;   //           m
  ch  : integer;
begin
  memo1.Clear;
  val(m1Edit.Text, m, ch);
  if ch <> 0 then begin
    Memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  if m <= 0 then begin
    Memo1.Text := 'm:ʂ̒l0([)傫ĂB';
    exit;
  end;
  val(h1Edit.Text, h, ch);
  if ch <> 0 then begin
    Memo1.Text := 'h:ɊԈႢ܂B';
    exit;
  end;
  if h <= 0 then begin
    Memo1.Text := 'h:̒l0([)傫ĂB';
    exit;
  end;
  val(kEdit.Text, k, ch);
  if ch <> 0 then begin
    Memo1.Text := 'k:CRWɊԈႢ܂B';
    exit;
  end;
  if k <= 0 then begin
    Memo1.Text := 'k:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(g1Edit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  t := sqrt(m / (g * k)) * arccosh(exp(h * k / m));
  v := sqrt(m * g / k) * tanh(t / sqrt(m / (g * k)));
  memo1.Lines.Append('');
  memo1.Lines.Append(' t = ' + floatTostr(t) + ' sec');
  memo1.Lines.Append('x');
  memo1.Lines.Append(' v = ' + floatTostr(v) + ' m/s');
end;

// xƋCRႷ̂Ƃtb̑xvZ
// k:CRWPʖ
procedure TForm1.vh3BtnClick(Sender: TObject);
var
  k   : double;   // CRW
  m   : double;   //           kg
  t   : double;   //       sec
  v   : double;   // x      m/s
  h   : double;   //           m
  g   : double;   // d͉x    m/sec^2
  ch  : integer;
begin
  memo1.Clear;
  val(g3Edit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  val(t3Edit.Text, t, ch);
  if ch <> 0 then begin
    Memo1.Text := 't:ԂɊԈႢ܂B';
    exit;
  end;
  if t <= 0 then begin
    Memo1.Text := 't:Ԃ̒l0([)傫ĂB';
    exit;
  end;
  val(k3Edit.Text, k, ch);
  if ch <> 0 then begin
    Memo1.Text := 'k:CRWɊԈႢ܂B';
    exit;
  end;
  if k <= 0 then begin
    Memo1.Text := 'k:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(m3Edit.Text, m, ch);
  if ch <> 0 then begin
    Memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  if m <= 0 then begin
    Memo1.Text := 'm:ʂ̒l0([)傫ĂB';
    exit;
  end;
  v :=  m * g / k - m * g / k * exp(-k * t / m);
  h :=  m / k * (m / k * g * (exp(-k * t / m) - 1) + g * t);
  memo1.Lines.Append('');
  memo1.Lines.Append(' h = ' + floatTostr(h) + ' m');
  memo1.Lines.Append('x');
  memo1.Lines.Append(' v = ' + floatTostr(v) + ' m/s');
end;

// CR̂ƂėԂ瑬xƋvZ
procedure TForm1.vh2BtnClick(Sender: TObject);
var
  t   : double;   //       sec
  v   : double;   // x      m/s
  h   : double;   //           m
  g   : double;   // d͉x    m/sec^2
  ch  : integer;
begin
  memo1.Clear;
  val(t2Edit.Text, t, ch);
  if ch <> 0 then begin
    Memo1.Text := 't:ԂɊԈႢ܂B';
    exit;
  end;
  if t <= 0 then begin
    Memo1.Text := 't:Ԃ̒l0([)傫ĂB';
    exit;
  end;
  val(g2Edit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  v := g * t;
  h := g * t * t / 2;
  memo1.Lines.Append('');
  memo1.Lines.Append(' h = ' + floatTostr(h) + ' m');
  memo1.Lines.Append('x');
  memo1.Lines.Append(' v = ' + floatTostr(v) + ' m/s');
end;

// CRx̂QɔႷ̂ƂĎԂ瑬xƋvZ
procedure TForm1.vhBtnClick(Sender: TObject);
var
  k   : double;   // CRW  kg/m
  m   : double;   //           kg
  t   : double;   //       sec
  g   : double;   // d͉x    m/sec^2
  v   : double;   // x      m/s
  h   : double;   //           m
  ch  : integer;
begin
  Memo1.Clear;
  val(kEdit.Text, k, ch);
  if ch <> 0 then begin
    Memo1.Text := 'k:CRWɊԈႢ܂B';
    exit;
  end;
  if k <= 0 then begin
    Memo1.Text := 'k:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(mEdit.Text, m, ch);
  if ch <> 0 then begin
    Memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  if m <= 0 then begin
    Memo1.Text := 'm:ʂ̒l0([)傫ĂB';
    exit;
  end;
  val(tEdit.Text, t, ch);
  if ch <> 0 then begin
    Memo1.Text := 't:ԂɊԈႢ܂B';
    exit;
  end;
  if t <= 0 then begin
    Memo1.Text := 't:Ԃ̒l0([)傫ĂB';
    exit;
  end;
  val(gEdit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  h := m / k * ln(cosh(t / sqrt(m / (g * k))));
  v := sqrt(m * g / k) * tanh(t / sqrt(m / (g * k)));
  memo1.Lines.Append('');
  memo1.Lines.Append(' h = ' + floatTostr(h) + ' m');
  memo1.Lines.Append('x');
  memo1.Lines.Append(' v = ' + floatTostr(v) + ' m/s');
end;

// CR͌WCRvZkg/mvZ
procedure TForm1.KcalcBtnClick(Sender: TObject);
var
  k   : double;   // CRW  kg/m
  Cd  : double;   // CR͌W
  r   : double;   // Cx   kg/m^3
  S   : double;   // \ʐ   m^2
  ch  : integer;
begin
  val(CdEdit.Text, Cd, ch);
  if ch <> 0 then begin
    Memo1.Text := 'Cd:CR͌WɊԈႢ܂B';
    exit;
  end;
  val(rhoEdit.Text, r, ch);
  if ch <> 0 then begin
    Memo1.Text := ':CxɊԈႢ܂B';
    exit;
  end;
  val(sumEdit.Text, S, ch);
  if ch <> 0 then begin
    Memo1.Text := 'S:\ʐςɊԈႢ܂B';
    exit;
  end;
  k := Cd * r * s / 2;
  kEdit.Text := floatTostr(k);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.Text := 'RvZ';
end;

end.
